
package de.ivu.elect.presentation.niederschrift.menu;

import de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderungConstants;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.niederschrift.NiederschriftStatusAenderungCreateView;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class NiederschriftStatusAenderungCreateMenuItemEntry extends AbstractNiederschriftMenuItemEntry {

  private static final long serialVersionUID = 1L;

  public NiederschriftStatusAenderungCreateMenuItemEntry() {
    super();
  }

  @Override
  public UseCasePermission getUseCasePermission() {
    return UseCasePermission.NIEDERSCHRIFT_STATUS_AENDERUNG_CREATE;
  }

  @Override
  protected boolean isDisabledInternal() {
    return false; // ELECTMUC-2749
  }

  @Override
  public AbstractGebietSecurity getGebietSecurity() {
    if (isNiederschriftErfassungMitWahlContext()) {
      return getBearbeitenGebietSecurity();
    }

    return super.getGebietSecurity();
  }

  @Override
  protected boolean isResetViewStackAllowed() {
    return false; // HINT: sonst können wir auf dem NiederschriftStatusAenderungSearchView nicht mehr den "Zurück"-Button betätigen
  }

  @Override
  public String getTargetViewId() {
    return NiederschriftStatusAenderungCreateView.VIEW_ID;
  }

  @Override
  protected String getLabel() {
    return getMessage(getLabelKey(), getMessage(NiederschriftStatusAenderungConstants.MESSAGE_KEY_ENTITY_MEHRZAHL));
  }

  @Override
  public String getLabelKey() {
    return "niederschrift.status.aenderung.create.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconEdit();
  }
}
